MWAWColor Struct Reference documentation

MWAWColor Struct Reference

the class to store a color More...

`#include <libmwaw_internal.hxx>`

## Public Member Functions
| MWAWColor (uint32_t argb=0)
| constructor
| MWAWColor (unsigned char r, unsigned char g, unsigned char b, unsigned char a=255)
| constructor from color
| MWAWColor (MWAWColor const &)=default
| copy constructor
| MWAWColor (MWAWColor &&)=default
| move assignement
MWAWColor & | operator= (MWAWColor const &)=default
| operator=
MWAWColor & | operator= (MWAWColor &&)=default
| move operator=
MWAWColor & | operator= (uint32_t argb)
| operator=
uint32_t | value () const
| return the rgba value
unsigned char | getAlpha () const
| returns the alpha value
unsigned char | getBlue () const
| returns the green value
unsigned char | getRed () const
| returns the red value
unsigned char | getGreen () const
| returns the green value
bool | isBlack () const
| return true if the color is black
bool | isWhite () const
| return true if the color is white
bool | operator== (MWAWColor const &c) const
| operator==
bool | operator!= (MWAWColor const &c) const
| operator!=
bool | operator< (MWAWColor const &c) const
| operator<
bool | operator<= (MWAWColor const &c) const
| operator<=
bool | operator> (MWAWColor const &c) const
| operator>
bool | operator>= (MWAWColor const &c) const
| operator>=
std::string | str () const
| print the color in the form #rrggbb

## Static Public Member Functions
static MWAWColor | colorFromCMYK (unsigned char c, unsigned char m, unsigned char y, unsigned char k)
| return a color from a cmyk color ( basic)
static MWAWColor | colorFromHSL (unsigned char H, unsigned char S, unsigned char L)
| return a color from a hsl color (basic)
static MWAWColor | black ()
| return the back color
static MWAWColor | white ()
| return the white color
static MWAWColor | barycenter (float alpha, MWAWColor const &colA, float beta, MWAWColor const &colB)
| return alpha*colA+beta*colB

## Protected Attributes
uint32_t | m_value
| the argb color

## Friends
std::ostream & | operator<< (std::ostream &o, MWAWColor const &c)
| operator<< in the form #rrggbb

## Detailed Description

the class to store a color

## Constructor & Destructor Documentation

## ◆ MWAWColor() [1/4]

MWAWColor::MWAWColor | ( | uint32_t | argb = 0 | ) |
| inlineexplicit

constructor

Referenced by barycenter(), black(), colorFromCMYK(), colorFromHSL(), MWAWColor(), MWAWColor(), operator!=(), operator<(), operator<<, operator<=(), operator=(), operator=(), operator=(), operator==(), operator>(), operator>=(), and white().

## ◆ MWAWColor() [2/4]

MWAWColor::MWAWColor | ( | unsigned char | r,
|  | unsigned char | g,
|  | unsigned char | b,
|  | unsigned char | a = 255 )
| inline

constructor from color

## ◆ MWAWColor() [3/4]

MWAWColor::MWAWColor | ( | MWAWColor const & |  | ) |
| default

copy constructor

## ◆ MWAWColor() [4/4]

MWAWColor::MWAWColor | ( | MWAWColor && |  | ) |
| default

move assignement

## Member Function Documentation

## ◆ barycenter()

MWAWColor MWAWColor::barycenter | ( | float | alpha,
|  | MWAWColor const & | colA,
|  | float | beta,
|  | MWAWColor const & | colB )
| static

return alpha*colA+beta*colB

Referenced by MWAWGraphicStyle::Pattern::getAverageColor(), MarinerWrtTextInternal::Paragraph::BorderFill::getBackgroundColor(), RagTime5StyleManager::getCellBackgroundColor(), RagTime5StyleManager::getCellBorder(), CricketDrawParserInternal::State::getColor(), HanMacWrdJGraphInternal::State::getColor(), HanMacWrdKGraphInternal::State::getColor(), MacWrtProStructures::getColor(), RagTime5StyleManager::getLineColor(), FreeHandParser::readColor(), RagTimeParser::readColorTable(), RagTimeParser::readDataZoneHeader(), LightWayTxtText::readFont2(), PowerPoint3Parser::readFramesList(), MacDrawProParser::readObject(), MsWksGraph::readPictHeader(), CricketDrawParser::readShape(), WingzParser::readSpreadsheetStyle(), CanvasGraph::sendMultiLines(), MarinerWrtGraph::sendRule(), CanvasGraph::update(), RagTime5StyleManager::updateBorderStyle(), RagTime5StyleManager::updateFrameStyle(), ClarisDrawStyleManager::updateGradient(), ClarisWksStyleManager::updateGradient(), and Canvas5StyleManager::updateLine().

## ◆ black()

MWAWColor MWAWColor::black | ( |  | ) |
| inlinestatic

return the back color

Referenced by RagTimeParser::createZones(), FullWrtText::FullWrtParser, MacDraft5StyleManagerInternal::Pixmap::get(), MWAWPictBitmapBW::getAverageColor(), MWAWPictBitmapColor::getAverageColor(), MWAWPictBitmapIndexed::getAverageColor(), DrawTableParser::getBitmap(), BeagleWksSSParserInternal::State::getColor(), CricketDrawParserInternal::State::getColor(), DrawTableParserInternal::State::getColor(), ClarisDrawStyleManagerInternal::Gradient::Gradient(), ClarisWksStyleManagerInternal::Gradient::Gradient(), MWAWGraphicStyle::Gradient::Gradient(), RagTime5StyleManager::GraphicStyle::GraphicStyle(), ClarisDrawStyleManagerInternal::State::initBWPatterns(), MacDrawProStyleManagerInternal::State::initBWPatterns(), MacDrawProStyleManagerInternal::State::initColors(), RagTime5StyleManagerInternal::State::initColorsList(), DrawTableParserInternal::State::initPatterns(), MacDraft5StyleManagerInternal::State::initPatterns(), MacDraftParserInternal::State::initPatterns(), MacDrawParserInternal::State::initPatterns(), WingzGraphInternal::State::initPatterns(), CanvasGraphInternal::Shape::operator<<, ClarisWksStyleManagerInternal::Pattern::Pattern(), HanMacWrdJGraphInternal::Pattern::Pattern(), HanMacWrdKGraphInternal::Pattern::Pattern(), MarinerWrtGraphInternal::Pattern::Pattern(), MWAWGraphicStyle::Pattern::Pattern(), MWAWGraphicStyle::Pattern::Pattern(), RagTimeParserInternal::Pattern::Pattern(), Canvas5StyleManagerInternal::PenStyle::PenStyle(), RagTimeText::RagTimeParser, RagTime5StyleManager::GraphicStyle::read(), BeagleWksBMParser::readBitmap(), Canvas5Structure::readBitmap(), MacPaintParser::readBitmap(), ScoopParser::readBitmap(), SuperPaintParser::readBitmap(), ApplePictParser::readBWPattern(), MacDrawProStyleManager::readBWPatterns(), libmwaw_applepict1::OpCode::readColor(), ApplePictParser::readColorPattern(), MacDrawProStyleManager::readColorPatterns(), RagTime5Graph::readColorPatternZone(), RagTimeParser::readDataZoneHeader(), FreeHandParser::readFillStyle(), ClarisWksStyleManager::readFont(), MsWrdTextStyles::readFont(), LightWayTxtText::readFont2(), ClarisWksStyleManager::readFontAndPos(), HanMacWrdJGraph::readFrames(), PowerPoint1Parser::readFramesList(), PowerPoint3Parser::readFramesList(), FreeHandParser::readLineStyle(), MacDrawProParser::readObject(), MacDraftParser::readPattern(), ClarisDrawStyleManager::readPatternList(), MacDrawProStyleManager::readPatternMap(), MacDraft5StyleManager::readPatterns(), SuperPaintParser::readShape(), ReadySetGoParser::readShapeV3(), GreatWksGraph::readStyle(), PowerPoint7Graph::readStyle(), HanMacWrdKGraph::readTable(), HanMacWrdJGraph::readTableFormatsList(), PowerPoint7Text::readTextZone(), CanvasParser::readUnknownZone0(), ApplePictParser::readZone(), MarinerWrtTextInternal::Paragraph::BorderFill::resetBackgroundColor(), MWAWFont::resetColor(), MacDrawProParser::send(), MacDraftParser::sendBitmap(), MacDrawParser::sendBitmap(), MacDrawProParser::sendBitmap(), ClarisDrawGraph::sendGroup(), ClarisDrawGraph::sendMainGroupChild(), CanvasGraph::sendMultiLines(), StudentWritingCParser::sendText(), and MWAWGraphicStyle::Gradient::Stop::Stop().

## ◆ colorFromCMYK()

MWAWColor MWAWColor::colorFromCMYK | ( | unsigned char | c,
|  | unsigned char | m,
|  | unsigned char | y,
|  | unsigned char | k )
| inlinestatic

return a color from a cmyk color ( basic)

Referenced by Canvas5StyleManager::readColor(), FreeHandParser::readColor(), MacDrawProStyleManager::readColorMap(), MacDrawProStyleManager::readColorPalette(), and MacDrawProStyleManager::readGradientPalette().

## ◆ colorFromHSL()

MWAWColor MWAWColor::colorFromHSL | ( | unsigned char | H,
|  | unsigned char | S,
|  | unsigned char | L )
| inlinestatic

return a color from a hsl color (basic)

Referenced by MacDrawProStyleManager::readColorMap(), and MacDrawProStyleManager::readColorPalette().

## ◆ getAlpha()

unsigned char MWAWColor::getAlpha | ( |  | ) | const
| inline

returns the alpha value

Referenced by MWAWPictBitmapColor::getAverageColor(), Canvas5StyleManager::updateLineColor(), and Canvas5StyleManager::updateSurfaceColor().

## ◆ getBlue()

unsigned char MWAWColor::getBlue | ( |  | ) | const
| inline

returns the green value

Referenced by MacDraft5StyleManagerInternal::Pixmap::get(), MWAWPictBitmapColor::getAverageColor(), RagTime5StyleManager::getCellBackgroundColor(), RagTime5StyleManager::getCellBorder(), MacDrawProStyleManager::readColorPatterns(), MacDrawProParser::readObject(), and RagTime5StyleManager::updateBorderStyle().

## ◆ getGreen()

unsigned char MWAWColor::getGreen | ( |  | ) | const
| inline

returns the green value

Referenced by MacDraft5StyleManagerInternal::Pixmap::get(), MWAWPictBitmapColor::getAverageColor(), RagTime5StyleManager::getCellBackgroundColor(), RagTime5StyleManager::getCellBorder(), MacDrawProStyleManager::readColorPatterns(), and RagTime5StyleManager::updateBorderStyle().

## ◆ getRed()

unsigned char MWAWColor::getRed | ( |  | ) | const
| inline

returns the red value

Referenced by MacDraft5StyleManagerInternal::Pixmap::get(), MWAWPictBitmapColor::getAverageColor(), RagTime5StyleManager::getCellBackgroundColor(), RagTime5StyleManager::getCellBorder(), MacDrawProStyleManager::readColorPatterns(), and RagTime5StyleManager::updateBorderStyle().

## ◆ isBlack()

bool MWAWColor::isBlack | ( |  | ) | const
| inline

return true if the color is black

Referenced by ActaTextInternal::Topic::operator<<, FullWrtStruct::Border::operator<<, FullWrtTextInternal::DataModifier::operator<<, MarinerWrtGraphInternal::Token::operator<<, MarinerWrtTextInternal::Paragraph::BorderFill::operator<<, MoreStruct::Pattern::operator<<, MWAWBorder::operator<<, MWAWGraphicStyle::Hatch::operator<<, MWAWGraphicStyle::operator<<, MWAWGraphicStyle::Pattern::operator<<, RagTimeParserInternal::Zone::operator<<, WingzGraph::readChartData(), MarinerWrtParser::readDocInfo(), MoreParser::readDocumentInfo(), WingzGraph::readGraphic(), GreatWksDocument::readGrDS(), MacDrawProParser::readObject(), PowerPoint3Parser::readParagraph(), CricketDrawParser::readShape(), SuperPaintParser::readShape(), PowerPoint7Graph::readStyle(), GreatWksSSParser::readStyles(), PowerPoint7Text::readTextZone(), MarinerWrtGraph::readToken(), CorelPainterParser::sendText(), PowerPoint1Parser::sendText(), and MacDraft5StyleManager::updateLineStyle().

## ◆ isWhite()

bool MWAWColor::isWhite | ( |  | ) | const
| inline

return true if the color is white

Referenced by FullWrtStruct::Border::operator<<, HanMacWrdJGraphInternal::CellFormat::operator<<, MacWrtProStructuresInternal::Graphic::operator<<, MarinerWrtParserInternal::Zone::operator<<, MarinerWrtTextInternal::Paragraph::BorderFill::operator<<, MoreStruct::Pattern::operator<<, MWAWCell::operator<<, MWAWGraphicStyle::operator<<, MWAWGraphicStyle::Pattern::operator<<, MWAWParagraph::operator<<, MWAWSection::operator<<, RagTimeSpreadsheetInternal::CellExtra::operator<<, WriteNowTextInternal::TableData::operator<<, WingzGraph::readChartData(), RagTimeParser::readDataZoneHeader(), MoreParser::readDocumentInfo(), WingzGraph::readGraphic(), GreatWksDocument::readGrDS(), MacDrawProParser::readObject(), CorelPainterParser::readResource(), CricketDrawParser::readShape(), SuperPaintParser::readShape(), WingzParser::readSpreadsheetStyle(), GreatWksSSParser::readStyles(), MarinerWrtParser::readZone13(), ClarisWksSpreadsheet::sendSpreadsheet(), MsWrdText::sendTable(), and MacDraft5StyleManager::updateSurfaceStyle().

## ◆ operator!=()

bool MWAWColor::operator!= | ( | MWAWColor const & | c | ) | const
| inline

operator!=

## ◆ operator<()

bool MWAWColor::operator< | ( | MWAWColor const & | c | ) | const
| inline

operator<

Referenced by operator>=().

## ◆ operator<=()

bool MWAWColor::operator<= | ( | MWAWColor const & | c | ) | const
| inline

operator<=

Referenced by operator>().

## ◆ operator=() [1/3]

MWAWColor & MWAWColor::operator= | ( | MWAWColor && |  | ) |
| default

move operator=

## ◆ operator=() [2/3]

MWAWColor & MWAWColor::operator= | ( | MWAWColor const & |  | ) |
| default

operator=

## ◆ operator=() [3/3]

MWAWColor & MWAWColor::operator= | ( | uint32_t | argb | ) |
| inline

operator=

## ◆ operator==()

bool MWAWColor::operator== | ( | MWAWColor const & | c | ) | const
| inline

operator==

Referenced by operator!=().

## ◆ operator>()

bool MWAWColor::operator> | ( | MWAWColor const & | c | ) | const
| inline

operator>

## ◆ operator>=()

bool MWAWColor::operator>= | ( | MWAWColor const & | c | ) | const
| inline

operator>=

## ◆ str()

std::string MWAWColor::str | ( |  | ) | const

print the color in the form #rrggbb

Referenced by MWAWFont::Line::addTo(), MWAWGraphicStyle::addTo(), MoreParser::readBackside(), WingzGraph::readChartData(), CanvasStyleManager::readGradient(), and MacWrtProStructures::readGraphic().

## ◆ value()

uint32_t MWAWColor::value | ( |  | ) | const
| inline

return the rgba value

Referenced by MWAWPictBitmapInternal::getBMPData(), MWAWPictBitmapInternal::getPPMData(), and CorelPainterParser::sendText().

## ◆ white()

MWAWColor MWAWColor::white | ( |  | ) |
| inlinestatic

return the white color

Referenced by DrawTableParser::getBitmap(), CanvasGraph::getBitmapBW(), BeagleWksSSParserInternal::State::getColor(), CricketDrawParserInternal::State::getColor(), DrawTableParserInternal::State::getColor(), HanMacWrdJGraphInternal::State::getColor(), HanMacWrdKGraphInternal::State::getColor(), MacWrtProStructures::getColor(), BeagleWksTextInternal::Font::getFont(), RagTime5StyleManager::getLineColor(), ClarisDrawStyleManagerInternal::Gradient::Gradient(), ClarisWksStyleManagerInternal::Gradient::Gradient(), MWAWGraphicStyle::Gradient::Gradient(), RagTime5StyleManager::GraphicStyle::GraphicStyle(), ClarisDrawStyleManagerInternal::State::initBWPatterns(), MacDrawProStyleManagerInternal::State::initBWPatterns(), MacDrawProStyleManagerInternal::State::initColors(), RagTime5StyleManagerInternal::State::initColorsList(), DrawTableParserInternal::State::initPatterns(), MacDraft5StyleManagerInternal::State::initPatterns(), MacDraftParserInternal::State::initPatterns(), MacDrawParserInternal::State::initPatterns(), WingzGraphInternal::State::initPatterns(), CanvasGraphInternal::Shape::operator<<, ClarisWksStyleManagerInternal::Pattern::Pattern(), HanMacWrdJGraphInternal::Pattern::Pattern(), HanMacWrdKGraphInternal::Pattern::Pattern(), MarinerWrtGraphInternal::Pattern::Pattern(), MWAWGraphicStyle::Pattern::Pattern(), MWAWGraphicStyle::Pattern::Pattern(), RagTimeParserInternal::Pattern::Pattern(), RagTime5StyleManager::GraphicStyle::read(), BeagleWksBMParser::readBitmap(), Canvas5Structure::readBitmap(), MacPaintParser::readBitmap(), ScoopParser::readBitmap(), SuperPaintParser::readBitmap(), ApplePictParser::readBWPattern(), MacDrawProStyleManager::readBWPatterns(), FreeHandParser::readColor(), libmwaw_applepict1::OpCode::readColor(), ApplePictParser::readColorPattern(), MacDrawProStyleManager::readColorPatterns(), RagTime5Graph::readColorPatternZone(), RagTimeParser::readColorTable(), RagTimeParser::readDataZoneHeader(), FreeHandParser::readFillStyle(), LightWayTxtText::readFont2(), MacDrawProStyleManager::readFontStyles(), HanMacWrdJGraph::readFrames(), PowerPoint1Parser::readFramesList(), PowerPoint3Parser::readFramesList(), MacWrtProStructures::readGraphic(), MacDraftParser::readLabel(), FreeHandParser::readLineStyle(), MacDrawProParser::readObject(), MacDraftParser::readPattern(), ClarisDrawStyleManager::readPatternList(), MacDrawProStyleManager::readPatternMap(), MacDraft5StyleManager::readPatterns(), CricketDrawParser::readShape(), ReadySetGoParser::readShapeV3(), BeagleWksDRParser::readStyle(), GreatWksGraph::readStyle(), PowerPoint7Graph::readStyle(), HanMacWrdKGraph::readTable(), HanMacWrdJGraph::readTableFormatsList(), ApplePictParser::readZone(), MarinerWrtTextInternal::Paragraph::BorderFill::resetBackgroundColor(), MWAWFont::resetColor(), Canvas5Graph::send(), CanvasGraph::send(), MacDrawProParser::send(), CricketDrawParser::sendBitmap(), Canvas5Graph::sendDimension(), CanvasGraph::sendDimension(), CanvasGraph::sendMultiLines(), BeagleWksDRParser::sendPictures(), MarinerWrtGraph::sendRule(), ClarisDrawGraph::sendShape(), MWAWPageSpan::setBackgroundColor(), FreeHandParserInternal::State::updateFillStyle(), FreeHandParserInternal::State::updateLineStyle(), and RagTime5StyleManager::updateSurfaceStyle().

## Friends And Related Symbol Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | o,
|  | MWAWColor const & | c )
| friend

operator<< in the form #rrggbb

## Member Data Documentation

## ◆ m_value

uint32_t MWAWColor::m_value
| protected

the argb color

Referenced by barycenter(), getAlpha(), getBlue(), getGreen(), getRed(), isBlack(), isWhite(), MWAWColor(), MWAWColor(), operator<(), operator<<, operator<=(), operator=(), operator==(), and value().

The documentation for this struct was generated from the following files:

- libmwaw_internal.hxx
- libmwaw_internal.cxx